#include "./Timer.h"
#include "./SMG.h"
#include "./LED.h"
#include "./NE555.h"
#include "./key.h"
#include "./PCF8591.h"
#include "./iic.h"
#include "./Sys.h"
#include "./config.h"

//ܶ
code unsigned char SMG_Duan[] =
{
	0xc0, //0
	0xf9, //1
	0xa4, //2
	0xb0, //3
	0x99, //4
	0x92, //5
	0x82, //6
	0xf8, //7
	0x80, //8
	0x90, //9
	0x88, //A
	0x83, //b
	0xc6, //C
	0xa1, //d
	0x86, //E
	0x8e 	//F
};

//λѡ
code unsigned char SMG_Wei[]=
{
	0X01,
	0X02,
	0X04,
	0X08,
	0X10,
	0X20,
	0X40,
	0X80,
};

//ʾƵʺ
void SMG_Display_Fre(ulong fre)
{
	uchar wei;//λѡֵ
	uchar fre1,fre2,fre3,fre4,fre5,fre6;//6λƵֵ
	
	fre1=fre/100000;
	fre2=fre%100000/10000;
	fre3=fre%10000/1000;
	fre4=fre%1000/100;
	fre5=fre%100/10;
	fre6=fre%10;
	
	/*************/
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,SMG_Wei[wei]);//дλѡ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0,SMG_Duan[0X0F]);
			break;
		
		case 1:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 2:
			if(fre1==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre1]);
			}
			break;
			
		case 3:
			if(fre1==0&&fre2==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre2]);
			}
			break;
			
		case 4:
			if(fre1==0&&fre2==0&&fre3==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre3]);
			}
			break;
			
		case 5:
			if(fre1==0&&fre2==0&&fre3==0&&fre4==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre4]);
			}
			break;
			
		case 6:
			if(fre1==0&&fre2==0&&fre3==0&&fre4==0&&fre5==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre5]);
			}
			break;
			
		case 7:
			if(fre1==0&&fre2==0&&fre3==0&&fre4==0&&fre5==0&&fre6==0)
			{
				Write_HC573(0XE0,0XFF);
			}
			else
			{
				Write_HC573(0XE0,SMG_Duan[fre6]);
			}
			break;
	}
	wei++;
	if(wei>7) wei=0;
}

//ʾѹ
void SMG_Display_Vol(uint vol)
{
	uchar wei;//λѡֵ
	uchar vol1,vol2,vol3;//3λѹֵ
	
	vol1=vol/100;
	vol2=vol%100/10;
	vol3=vol%10;
	
	/*************/
	Write_HC573(0XC0,0XFF);
	Write_HC573(0XE0,0XFF);
	
	Write_HC573(0XC0,SMG_Wei[wei]);//дλѡ
	switch(wei)
	{
		case 0:
			Write_HC573(0XE0,0XC1);//U
			break;
		
		case 1:
			Write_HC573(0XE0,0XFF);
			break;
		
		case 2:
			Write_HC573(0XE0,0XFF);
			break;
			
		case 3:
			Write_HC573(0XE0,0XFF);
			break;
			
		case 4:
			Write_HC573(0XE0,0XFF);
			break;
			
		case 5:
			Write_HC573(0XE0,SMG_Duan[vol1]&0x7f);
			break;
			
		case 6:
			Write_HC573(0XE0,SMG_Duan[vol2]);
			break;
			
		case 7:
			Write_HC573(0XE0,SMG_Duan[vol3]);
			break;
	}
	wei++;
	if(wei>7) wei=0;	
}

//ʾлܺ
void SMG_Page_Func()
{
	if(key_sta.Key_Page==0)//ʾǵѹ
	{
		SMG_Display_Vol(pcf8591_tag.ADC_Val);//ʾѹ
	}
	else if(key_sta.Key_Page==1)//ʾƵʲ
	{
		SMG_Display_Fre(ne555_tag.NE555_Temp);//ʾƵʺ
	}
}

//ʾ
void SMG_Display_ENABLE()
{
	if(key_sta.Key_SMG_Power==0)//ܿ
	{
		SMG_Page_Func();//ʾлܺ
	}
	else if(key_sta.Key_SMG_Power==1)//ܿ
	{
		Write_HC573(0XC0,0XFF);//ѡλѡ
		Write_HC573(0XE0,0XFF);//ѡλѡ
	}
}